From bb16d53057c9c87b0b79965f856176a154be73bc Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 17 2020 06:04:17 +0000
Subject: [PATCH 144/2232] Split the fallible function error message


---

diff --git a/syntax/check.rs b/syntax/check.rs
index 80937bb..4c2fff3 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -1,5 +1,5 @@
 use crate::syntax::atom::Atom::{self, *};
-use crate::syntax::{error, ident, Api, ExternFn, Ref, Ty1, Type, Types, Var};
+use crate::syntax::{error, ident, Api, ExternFn, Lang::*, Ref, Ty1, Type, Types, Var};
 use proc_macro2::Ident;
 use syn::{Error, Result};
 
@@ -69,10 +69,16 @@ pub(crate) fn typecheck(apis: &[Api], types: &Types) -> Result<()> {
                         errors.push(return_by_value(ty, types));
                     }
                 }
-                if efn.throws {
+                if efn.throws && efn.lang == Cxx {
                     errors.push(Error::new_spanned(
                         efn,
-                        "fallible functions are not implemented yet",
+                        "fallible C++ functions are not implemented yet",
+                    ));
+                }
+                if efn.throws && efn.lang == Rust {
+                    errors.push(Error::new_spanned(
+                        efn,
+                        "fallible Rust functions are not implemented yet",
                     ));
                 }
             }

